diff -urN config/configure.in config/configure.in
--- config/configure.in	2005-10-28 11:04:17.000000000 +0200
+++ config/configure.in	2005-10-31 13:47:17.000000000 +0100
@@ -811,7 +811,7 @@
         AC_MSG_CHECKING(for librsvg - version >= $REQUIRED_RSVG)
         if pkg-config --atleast-version $REQUIRED_RSVG $PKG_RSVG; then
           GTK_CONFIG="pkg-config $PKG_GTK $PKG_RSVG"
-          REQUIRED_LABLGTK=2.4.0
+          REQUIRED_LABLGTK=2.6.0
           LABLGTK_NAME=lablgtk2
           AC_MSG_RESULT(yes)
         else
diff -urN src/gtk2/gui/graphTypes.ml src/gtk2/gui/graphTypes.ml
--- src/gtk2/gui/graphTypes.ml	1970-01-01 01:00:00.000000000 +0100
+++ src/gtk2/gui/graphTypes.ml	2005-02-02 22:18:03.000000000 +0100
@@ -0,0 +1,45 @@
+(* Copyright 2004 b8_bavard, INRIA *)
+(*
+    This file is part of mldonkey.
+
+    mldonkey is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    mldonkey is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with mldonkey; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*)
+
+open CommonTypes
+
+type graph =
+  {
+   mutable quarter : (float * float) list;
+   mutable hour    : (float * float) list;
+   mutable halfday : (float * float) list;
+   mutable day     : (float * float) list;
+   mutable week    : (float * float) list;
+   mutable month   : (float * float) list;
+   mutable year    : (float * float) list;
+  }
+
+type graph_record =
+  GraphDownloads
+| GraphUploads
+| GraphFile of (uid_type * graph_record)
+
+type graph_time =
+  GraphQuarter
+| GraphHour
+| GraphHalfDay
+| GraphDay
+| GraphWeek
+| GraphMonth
+| GraphYear
diff -urN src/gtk2/gui/guiArt.ml src/gtk2/gui/guiArt.ml
--- src/gtk2/gui/guiArt.ml	2005-10-10 18:22:25.000000000 +0200
+++ src/gtk2/gui/guiArt.ml	2005-10-23 14:25:44.000000000 +0200
@@ -556,117 +556,3 @@
              lprintf' "   -----------------------\n   avail_bars : %d bars\n"  (List.length l)
            end
        end
-
-
-
-(*
-doesn't work ! pixbuf are freed as soon as they are rendered !!!!
-
-open Gui_types
-
-let dummy_bar =
-  {
-   finder = ("", "", true);
-   pixbuf = GdkPixbuf.create ~width:1 ~height:1 ();
-  }
-
-module H = Weak.Make(struct
-  type t = avail_bar
-  let hash s = Hashtbl.hash s.finder
-            
-  let equal x y = x.finder = y.finder
-end)
-
-let avail_bars = H.create 1023
-
-let f = (fun _ ->
-  Printf.printf "Finalising availability bar\n";
-  flush stdout
-  )
-
-let get_availability_of availability chunks is_file =
-  let height = 16 in
-  let nchunks = String.length chunks in
-  let avail =
-    if is_file
-      then begin
-        let s = String.copy availability in
-        normalize_availability s;
-        s
-      end else availability
-  in
-  let key = (avail, chunks, is_file) in
-  try
-    Printf.printf "Trying to use an existing availability bar\n";
-    flush stdout;
-    let bar = {dummy_bar with finder = (avail, chunks, is_file)} in
-    let pixb = H.find avail_bars bar in
-    pixb
-  with _ ->
-    begin
-      Printf.printf "Creating new availability bar\n";
-      flush stdout;
-      let pixmap = GDraw.pixmap ~width:nchunks ~height
-        ~colormap:(Gdk.Color.get_system_colormap ()) ()
-      in
-      (try
-        for i = 0 to (nchunks - 1) do
-          if is_file
-            then if chunks.[i] >= '2'
-              then pixmap#put_pixmap
-                     ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                     color_green#pixmap
-              else begin
-                let h = int_of_char (avail.[i]) in
-                if h = 0
-                  then if chunks.[i] = '0'
-                    then pixmap#put_pixmap
-                           ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                           color_red#pixmap
-                    else pixmap#put_pixmap
-                           ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                           color_orange#pixmap
-                  else begin
-                    let color_blue = !color_blue_relative.(!!O.gtk_misc_availability_max - h) in
-                    pixmap#put_pixmap
-                      ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                      color_blue#pixmap
-                  end
-              end
-            else if int_of_char avail.[i] >= 49
-              then if chunks.[i] >= '2'
-                then pixmap#put_pixmap
-                       ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                       color_black#pixmap
-                else pixmap#put_pixmap
-                       ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                       color_green#pixmap
-              else if chunks.[i] > '2'
-                then pixmap#put_pixmap
-                       ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                       color_orange#pixmap
-                else pixmap#put_pixmap
-                       ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                       color_red#pixmap
-          done;
-
-      with _ ->
-          begin
-            for i = 0 to nchunks do
-              pixmap#put_pixmap
-                ~x:i ~y:0 ~xsrc:0 ~ysrc:0 ~width:1 ~height:height
-                color_grey#pixmap
-            done
-          end);
-    let pb = GdkPixbuf.create ~width:nchunks ~height ~has_alpha:false () in
-    GdkPixbuf.get_from_drawable 
-       ~dest:pb ~dest_x:0 ~dest_y:0 
-       ~width:nchunks ~height ~src_x:0 ~src_y:0
-       ~colormap:(Gdk.Color.get_system_colormap ()) 
-       pixmap#pixmap;
-    let bar = {dummy_bar with finder = key; pixbuf = pb} in
-    Gc.finalise f bar;
-    H.add avail_bars bar;
-    bar
-  end
-*)
diff -urN src/gtk2/gui/guiConfig.ml src/gtk2/gui/guiConfig.ml
--- src/gtk2/gui/guiConfig.ml	2005-05-13 23:15:47.000000000 +0200
+++ src/gtk2/gui/guiConfig.ml	2005-10-16 12:34:47.000000000 +0200
@@ -61,7 +61,8 @@
       | "Filename" -> BFilename
       | "Path" -> BPath
       | "Password" -> BPassword
-      | "Time" -> BTime
+      | "GraphTime" -> BCombo
+      | "Time" -> BInt
       | "Color" -> BColor
       | "Font" -> BFont
       | "Int" -> BInt
@@ -185,6 +186,7 @@
 let nap_server_reg = Str.regexp_case_fold ".*napigator.*\\|.*server.*"
 let slsk_client_reg = Str.regexp_case_fold ".*client_.*\\|.*login.*\\|.*password.*"
 let slsk_sources_reg = Str.regexp_case_fold ".*token.*\\|.*clients.*\\|.*cache_.*"
+let mlgui_connection_reg = Str.regexp_case_fold ".*gtk_connection.*"
 let mlgui_client_reg = Str.regexp_case_fold ".*gtk_client_.*"
 let mlgui_look_reg = Str.regexp_case_fold ".*gtk_look_.*"
 let mlgui_color_reg = Str.regexp_case_fold ".*gtk_color_.*"
@@ -207,9 +209,10 @@
         [(Some display_reg, Some Display_conf); (Some look_reg, Some Look);
          (None, Some General_)];
    (Some Interfaces, Some Mlgui),
-        [(Some mlgui_client_reg, Some Client); (Some mlgui_look_reg, Some Look);
-         (Some mlgui_color_reg, Some Colors); (Some mlgui_font_reg, Some Fonts);
-         (Some mlgui_graph_reg, Some Graph); (None, Some Others)];
+        [(Some mlgui_connection_reg, Some Proxy); (Some mlgui_client_reg, Some Client);
+         (Some mlgui_look_reg, Some Look); (Some mlgui_color_reg, Some Colors);
+         (Some mlgui_font_reg, Some Fonts);(Some mlgui_graph_reg, Some Graph);
+         (None, Some Others)];
    (Some Tools, Some Startup),
         [(Some gui_reg, Some Gui); (None, Some User)];
    (Some Tools, Some Mail),
@@ -321,6 +324,15 @@
           | "gtk_client_lang" ->
               (p.pref_option_list <- U.languages;
                BCombo)
+          | "gtk_graph_time_downloads" ->
+              (p.pref_option_list <- ["quarter"; "hour"; "half_day"; "day"; "week"; "month"; "year"];
+               p.pref_type)
+          | "gtk_graph_time_uploads" ->
+              (p.pref_option_list <- ["quarter"; "hour"; "half_day"; "day"; "week"; "month"; "year"];
+               p.pref_type)
+          | "gtk_graph_time_file" ->
+              (p.pref_option_list <- ["quarter"; "hour"; "half_day"; "day"; "week"; "month"; "year"];
+               p.pref_type)
           | _ -> p.pref_type
       end
   | _ -> p.pref_type
@@ -381,6 +393,9 @@
             let _ =
               match o.M.option_name with
                   "client_name" -> G.client_name := o.M.option_value
+                | "max_hard_download_rate" -> G.max_hard_download_rate := int_of_float (safe_int o.M.option_value)
+                | "max_hard_upload_rate" -> G.max_hard_upload_rate := int_of_float (safe_int o.M.option_value)
+                | "update_gui_delay" -> G.update_gui_delay := int_of_float (1000. *. safe_float o.M.option_value)
                 | _ -> ()
             in
             try
diff -urN src/gtk2/gui/guiConsole.ml src/gtk2/gui/guiConsole.ml
--- src/gtk2/gui/guiConsole.ml	2005-03-02 20:45:11.000000000 +0100
+++ src/gtk2/gui/guiConsole.ml	2005-10-23 14:26:38.000000000 +0200
@@ -92,8 +92,6 @@
   ignore (text_buffer#connect#changed ~callback:
     (fun _ ->
        let nlines = text_buffer#line_count in
-       (* Printf.printf "Buffer modified %d\n" nlines;
-       flush stdout; *)
        if nlines > 1000
          then begin
            let stop = text_buffer#get_iter `END in
